using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Data.SqlClient;

public partial class Templates_SSCallback : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack && !IsCallback)
        {
            DataTable dt = GetNodes("");
            foreach (DataRow dr in dt.Rows)
            {
                RadTreeNode node = new RadTreeNode();
                node.Text = dr["Text"].ToString();
                node.Value = dr["id"].ToString();
                node.ExpandMode = TreeNodeExpandMode.ServerSideCallBack;
                RadTreeView1.Nodes.Add(node);
            }
            RadTreeView1.DataBind();
        }
    }

    private DataTable GetNodes(string id)
    {
        SqlConnection conn = new SqlConnection();
        conn.ConnectionString = ConfigurationManager.ConnectionStrings["TelerikConnectionString2"].ConnectionString;
        
        string sql = "SELECT * FROM Links";

        if (id != string.Empty)
        {
            sql += " WHERE parentId = " + id;
        }
        else
        {
            sql += " WHERE parentId is null";
        }

        SqlDataAdapter adapter = new SqlDataAdapter(sql, conn);

        DataTable dt = new DataTable();
        conn.Open();
        adapter.Fill(dt);
        conn.Close();
        return dt;
    }


    protected void RadTreeView1_NodeExpand(object sender, RadTreeNodeEventArgs e)
    {
        DataTable dt = GetNodes(e.Node.Value);

        foreach (DataRow dr in dt.Rows)
        {
            RadTreeNode node = new RadTreeNode();
            node.Text = dr["Text"].ToString();
            node.Value = dr["id"].ToString();
            node.ExpandMode = TreeNodeExpandMode.ServerSideCallBack;            
            e.Node.Nodes.Add(node);
            node.DataBind();
        }
    }
}
